<?php

namespace Drp\SimpleCms\Http\Middleware;

use Drp\SimpleCms\Scopes\PublishedScope;
use Closure;

/**
 * Class Published
 * @package Drp\SimpleCms
 */
class Published
{
    /**
     * Add the published scope to all the Content within the application.
     * This Middleware can then be applied to front end only routes
     * So only published content is visible to the end user.
     *
     * @param  mixed $request
     * @param  \Closure $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        if (!preview_mode_enabled()) {
            collect(config('simple_cms.content_types'))
                ->each(function ($study) {
                    $study::addGlobalScope(new PublishedScope);
                });
        }

        return $next($request);
    }
}
