<?php

namespace Drp\SimpleCms\Scopes;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Scope;

/**
 * Class PreviewScope
 * @package Drp\SimpleCms
 */
class PreviewScope implements Scope
{
    /**
     * Apply the scope to the Eloquent query builder.
     * This will return the Draft version over the
     * Published version if the content has one
     *
     * @param \Illuminate\Database\Eloquent\Builder $builder
     * @param \Illuminate\Database\Eloquent\Model $model
     * @return void
     * @SuppressWarnings("unused")
     */
    public function apply(Builder $builder, Model $model)
    {
        $builder->whereDraftOrInReview()
            ->orWhere(function ($query) {
                $query->wherePublished()
                    ->hasNoDraftOrInReview();
            });
    }
}
