<?php

namespace Drp\SimpleCms\Test\Support\Helpers;

use Drp\SimpleCms\Contracts\Publishable;


/**
 * trait InteractsWithPublishing
 * @package Tests\Helpers
 */
trait InteractsWithPublishing
{
    public function assertAllDraftOptionsAreAvailable()
    {
        $this->within('#draft-actions', function () {
            $this->seeText(Publishable::STATUS_DRAFT)
                ->seeLink(trans('simpleCms::content.reset'))
                ->seeLink(trans('simpleCms::content.review'))
                ->seeLink(trans('simpleCms::content.publish-draft'));

        });

        return $this;
    }

    public function assertInitialDraftOptionsAreAvailable()
    {
        $this->within('#draft-actions', function () {
            $this->seeText(Publishable::STATUS_DRAFT)
                ->dontSeeLink(trans('simpleCms::content.reset'));

        });

        return $this;
    }

    public function assertPublishedOptionsAreVisible()
    {
        $this->within('#publish-actions', function () {
            $this->seeText('published')
                ->seeLink(trans('simpleCms::content.original'))
                ->seeLink(trans('simpleCms::content.unpublish'));
        });

        return $this;
    }

    public function assertUnPublishedOptionsAreVisible()
    {
        $this->within('#publish-actions', function () {
            $this->seeText('unpublished')
                ->seeLink(trans('simpleCms::content.publish'));
        });

        return $this;
    }
}
