<?php

namespace Drp\SimpleCms\Test\Unit;

use Drp\SimpleCms\Http\Requests\ContentRequest;
use Drp\SimpleCms\Test\Support\Fakes\TestContent;
use Drp\SimpleCms\Test\TestCase;

/**
 * Class ContentRequestTest
 * @package Drp\SimpleCms\Test\Unit
 */
class ContentRequestTest extends TestCase
{
    /**
     * @test
     */
    public function it_uses_the_contents_call_back_to_manipulate_the_request()
    {
        $content = new TestContent();
        $timesCallbackRan = 0;

        $content->requestCallback = function ($request) use (&$timesCallbackRan) {
            $request->merge(['foo' => 'bar'], $request->input());
            $timesCallbackRan++;
        };

        $request = new ContentRequest();
        $request->prepareInput($content);
        $this->assertEquals(1, $timesCallbackRan);
        $this->assertEquals('bar', $request->get('foo'));
    }
}
